<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIndCoverageReqsTypePreexistingCondition ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfIndCoverageReqsTypePreexistingCondition extends AbstractStructArrayBase
{
    /**
     * The PreexistingCondition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition[]
     */
    public $PreexistingCondition;
    /**
     * Constructor method for ArrayOfIndCoverageReqsTypePreexistingCondition
     * @uses DgArrayOfIndCoverageReqsTypePreexistingCondition::setPreexistingCondition()
     * @param \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition[] $preexistingCondition
     */
    public function __construct(array $preexistingCondition = array())
    {
        $this
            ->setPreexistingCondition($preexistingCondition);
    }
    /**
     * Get PreexistingCondition value
     * @return \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition[]|null
     */
    public function getPreexistingCondition()
    {
        return $this->PreexistingCondition;
    }
    /**
     * Set PreexistingCondition value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition[] $preexistingCondition
     * @return \dgsoft\ArrayType\DgArrayOfIndCoverageReqsTypePreexistingCondition
     */
    public function setPreexistingCondition(array $preexistingCondition = array())
    {
        foreach ($preexistingCondition as $arrayOfIndCoverageReqsTypePreexistingConditionPreexistingConditionItem) {
            // validation for constraint: itemType
            if (!$arrayOfIndCoverageReqsTypePreexistingConditionPreexistingConditionItem instanceof \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition) {
                throw new \InvalidArgumentException(sprintf('The PreexistingCondition property can only contain items of \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition, "%s" given', is_object($arrayOfIndCoverageReqsTypePreexistingConditionPreexistingConditionItem) ? get_class($arrayOfIndCoverageReqsTypePreexistingConditionPreexistingConditionItem) : gettype($arrayOfIndCoverageReqsTypePreexistingConditionPreexistingConditionItem)), __LINE__);
            }
        }
        $this->PreexistingCondition = $preexistingCondition;
        return $this;
    }
    /**
     * Add item to PreexistingCondition value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition $item
     * @return \dgsoft\ArrayType\DgArrayOfIndCoverageReqsTypePreexistingCondition
     */
    public function addToPreexistingCondition(\dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition) {
            throw new \InvalidArgumentException(sprintf('The PreexistingCondition property can only contain items of \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PreexistingCondition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgIndCoverageReqsTypePreexistingCondition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PreexistingCondition
     */
    public function getAttributeName()
    {
        return 'PreexistingCondition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfIndCoverageReqsTypePreexistingCondition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
